<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F120 - Quản trị Order</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Loại Pizza</label>
        </div>
        <div class="col-sm-6">
          <select id="gPizzaTypeSelect" class="form-control">

          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Mã order</th>
            <th>Loại Pizza</th>
            <th>Tên khách hàng</th>
            <th>Ngày đặt hàng</th>
            <th>Trạng thái</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [
        {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
        },
        {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
        },
        {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
        },
        {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
        },
        {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
        }
      ];

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: 10,
          typeName: "Hải Sản"
        },
        {
          typeId: 15,
          typeName: "Bò bít tết"
        },
        {
          typeId: 20,
          typeName: "Thịt gà"
        }
      ];
      const ARRAY_NAME_COL = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
      const COL_ID = 0;
      const COL_ORDERCODE = 1;
      const COL_PIZZA_TYPE_ID = 2;
      const COL_CUSTOMER = 3;
      const COL_DATE = 4;
      const COL_STATUS = 5;
      const COL_ACTION = 6;
      var gStt = 1;
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoadDing();
      $("#btn-filter-order").on("click", function () {
        onBtnFilterClick();
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoadDing() {
        $('#order-table').DataTable({
          data: gOrderObjects,
          columns: [
            { data: ARRAY_NAME_COL[COL_ID] },
            { data: ARRAY_NAME_COL[COL_ORDERCODE] },
            { data: ARRAY_NAME_COL[COL_PIZZA_TYPE_ID] },
            { data: ARRAY_NAME_COL[COL_CUSTOMER] },
            { data: ARRAY_NAME_COL[COL_DATE] },
            { data: ARRAY_NAME_COL[COL_STATUS] },
            { data: ARRAY_NAME_COL[COL_ACTION] },
          ],
          columnDefs: [
            {
              targets: COL_ID,
              render: function (data) {
                return gStt++;
              }
            },
            {
              targets: COL_ACTION,
              defaultContent: '<i title="Edit" class="fas fa-edit" style="cursor: pointer; color:green;"></i>&nbsp;<i title="Delete" class="fas fa-trash" style="cursor: pointer; color:red;"></i>'
            }
          ],
        });
        loadDataToSelect(gPizzaType);
      }
      function onBtnFilterClick() {
        // tạo đối tượng chứa điều kiện lọc
        var vFilter = {
          pizzaTypeID: 0,
        }
        // thu thập dữ liệu
        getDataForm(vFilter);
        console.log(vFilter);
        // lọc dữ liệu
        var vResultFilter = filterData(vFilter);
        console.log(vResultFilter);
        // hiện thị dữ liệu
        disPlayDataToTable(vResultFilter);
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function getDataForm(paramData) {
        paramData.pizzaTypeID = $("#gPizzaTypeSelect").val();
      }
      //
      function filterData(paramData) {
        var vResult = [];
        vResult = gOrderObjects.filter(function (item) {
          return (item.gPizzaTypeId == paramData.pizzaTypeID || paramData.pizzaTypeID == 0);
        })
        return vResult;
      }
      function disPlayDataToTable(paramData) {
        gStt = 1;
        var vTable = $("#order-table").DataTable();
        vTable.clear(); // xoá dữ liệu của datatable
        vTable.rows.add(paramData);
        vTable.draw();
      }
      // hàm đổ dữ liệu vào ô select
      // Input là dữ liệu cần đổ vào 
      function loadDataToSelect(paramData) {
        $('#gPizzaTypeSelect').append($('<option>', {
          value: 0,
          text: 'Chọn Loại Pizza'
        }));
        for (var bI = 0; bI < paramData.length; bI++) {
          $('#gPizzaTypeSelect').append($('<option>', {
            value: paramData[bI].typeId,
            text: paramData[bI].typeName
          }));
        }
      }
      // hàm trả về pizzaTypeName dựa vào typeId
      function getPizzaNameByTypeId(paramTypeId) {
        "use strict";
        var vPizzaTypeName = "";
        var vIndex = 0;
        var vIsTypeFound = false;
        while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
            vIsTypeFound = true;
            vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
            vIndex++;
          }
        }
        return vPizzaTypeName;
      }

    </script>
</body>

</html>